/*
 * Created on Jul 18, 2005
 * 
 * This class contains tests of the sum function in SomeClass.  A fixture is
 * used to remove redundant initialization code. 
 */

/**
 * @author alan
 */
import org.junit.*; 
import static org.junit.Assert.*;

public class SomeClassTest2 {
    
    /* 
     * @see junit.framework.TestCase#setUp()
     *
     * This setup function initializes the array used in the tests and the
     * instance of SomeClass used in the tests.  It is called for each
     * function, so each function is free to overwrite elements of the array. 
     */
    @Before
    public void setUp() throws Exception {
        scla = new SomeClass();
        nums = new int[3];
        nums[0] = 1;
        nums[1] = 2;
        nums[2] = 3;
    }

    /* 
     * testSumNoNums: Tests summing no elements of the array. 
     *
     * Expected result: The sum is 0
     */
    @Test
    public void testSumNoNums() {
        assertEquals("sum none test", 0, scla.sum(nums, 0));
    }

    /* 
     * testSumTwoNums: Tests summing the first two elements of the array. 
     *
     * Expected result: The sum is 3
     */
    @Test
    public void testSumTwoNums() {
        assertEquals("sum two test", 3, scla.sum(nums, 2));
    }

    /* 
     * testSumAllNums: Tests summing all three elements of the array. 
     *
     * Expected result: The sum is 6
     */
    @Test 
    public void testSumAllNums() {
        assertEquals("sum all test", 6, scla.sum(nums, 3));
    }

    /* 
     * testSumLargerThanArray: Tests summing beyond the bounds of the array. 
     *
     * Expected result: The sum is 6 (all elements in the array)
     */
    @Test 
    public void testBeyondBounds() {
        assertEquals("beyond bounds test", 6, scla.sum(nums, 4));
    }
    
    private SomeClass scla;
    private int[] nums;
}
